<?php

// XML processing code design from http://www.kirupa.com/web/xml_php_parse_intermediate.htm

// global temp data
$current_tag = "";
$counter = 0;
$parsed_arr = array();
$uid = 0;

// friends/followers parser
class f_user{
	var $id, $name, $sname, $loc, $desc, $purl, $url, $protected;
}

function fl_contents($parser, $data) {
	global $current_tag, $parsed_arr, $counter;
	//echo $current_tag . ": " . $data . " (" . $counter . ")<br/>\n";
	switch($current_tag){
		case "*USERS*USER*ID":
			$counter++;
			$parsed_arr[$counter] = new f_user();
			$parsed_arr[$counter]->id = $data;
			break;
		case "*USERS*USER*NAME":
			$parsed_arr[$counter]->name .= $data;
			break;
		case "*USERS*USER*SCREEN_NAME":
			$parsed_arr[$counter]->sname .= $data;
			break;
		case "*USERS*USER*LOCATION":
			$parsed_arr[$counter]->loc .= $data;
			break;
		case "*USERS*USER*DESCRIPTION":
			$parsed_arr[$counter]->desc .= $data;
			break;
		case "*USERS*USER*PROFILE_IMAGE_URL":
			$parsed_arr[$counter]->purl .= $data;
			break;
		case "*USERS*USER*URL":
			$parsed_arr[$counter]->url .= $data;
			break;
		case "*USERS*USER*PROTECTED":
			$parsed_arr[$counter]->protected .= $data;
			break;
		case "*USERS":
		case "*USERS*USER":
		case "*USERS*USER*FOLLOWERS_COUNT":
		case "*USERS*USER*STATUS":
		case "*USERS*USER*STATUS*ID":
		case "*USERS*USER*STATUS*TEXT":
		case "*USERS*USER*STATUS*TEXT*SOURCE":
		case "*USERS*USER*STATUS*TRUNCATED":
		case "*USERS*USER*STATUS*FAVORITED":
		case "*USERS*USER*FOLLOWERS_COUNT":
		case "*USERS*USER*STATUS*CREATED_AT":
		case "*USERS*USER*STATUS*SOURCE":
		case "*USERS*USER*STATUS*IN_REPLY_TO_STATUS_ID":
		case "*USERS*USER*STATUS*IN_REPLY_TO_USER_ID":
		case "*USERS*USER*STATUS*IN_REPLY_TO_SCREEN_NAME":
			// ignore
			break;
		default:
			echo "<!-- " . $counter . " unsupported follower tag: "
			. $current_tag . " = " . $data . " -->\n";
			break;
	}
}

function fd_contents($parser, $data) {
	global $current_tag, $parsed_arr, $counter;
	//echo $current_tag . ": " . $data . " (" . $counter . ")<br/>\n";
	switch($current_tag){
		case "*USERS*USER*ID":
			$counter++;
			$parsed_arr[$counter] = new f_user();
			$parsed_arr[$counter]->id = $data;
			break;
		case "*USERS*USER*NAME":
			$parsed_arr[$counter]->name .= $data;
			break;
		case "*USERS*USER*SCREEN_NAME":
			$parsed_arr[$counter]->sname .= $data;
			break;
		case "*USERS*USER*LOCATION":
			$parsed_arr[$counter]->loc .= $data;
			break;
		case "*USERS*USER*DESCRIPTION":
			$parsed_arr[$counter]->desc .= $data;
			break;
		case "*USERS*USER*PROFILE_IMAGE_URL":
			$parsed_arr[$counter]->purl .= $data;
			break;
		case "*USERS*USER*URL":
			$parsed_arr[$counter]->url .= $data;
			break;
		case "*USERS*USER*PROTECTED":
			$parsed_arr[$counter]->protected .= $data;
			break;
		case "*USERS":
		case "*USERS*USER":
		case "*USERS*USER*FOLLOWERS_COUNT":
		case "*USERS*USER*STATUS":
		case "*USERS*USER*STATUS*ID":
		case "*USERS*USER*STATUS*TEXT":
		case "*USERS*USER*STATUS*TEXT*SOURCE":
		case "*USERS*USER*STATUS*TRUNCATED":
		case "*USERS*USER*STATUS*FAVORITED":
		case "*USERS*USER*FOLLOWERS_COUNT":
		case "*USERS*USER*STATUS*CREATED_AT":
		case "*USERS*USER*STATUS*SOURCE":
		case "*USERS*USER*STATUS*IN_REPLY_TO_STATUS_ID":
		case "*USERS*USER*STATUS*IN_REPLY_TO_USER_ID":
		case "*USERS*USER*STATUS*IN_REPLY_TO_SCREEN_NAME":
			// ignore
			break;
		default:
			echo "<!-- " . $counter . " unsupported friend tag: " . $current_tag
			.  " = " . $data . " -->\n";
			break;
	}
}

// users parser
function u_contents($parser, $data) {
	global $current_tag, $uid;
	switch($current_tag){
		case "*USER*ID":
			$uid = $data;
			break;
	}
}

// friend_timeline parser
class ft_status{
	var $created, $text, $tid, $uid, $name, $screen_name, $purl, $protected;
}

function ft_contents($parser, $data) {
	global $current_tag, $parsed_arr, $counter;

	//echo $current_tag . ": " . $data . " (" . $counter . ")<br/>\n";
	switch($current_tag){
		case "*STATUSES*STATUS*CREATED_AT":
			$counter++;
			$parsed_arr[$counter] = new ft_status();
			//'YYYY-MM-DD HH:MM:SS' Fri Apr 13 02:51:08 +0000 2007
			$parsed_arr[$counter]->created = $data;
			break;
		case "*STATUSES*STATUS*ID":
			$parsed_arr[$counter]->tid = $data;
			break;
		case "*STATUSES*STATUS*TEXT":
			$parsed_arr[$counter]->text .= $data;
			break;
		case "*STATUSES*STATUS*USER*ID":
			$parsed_arr[$counter]->uid = $data;
			break;
		case "*STATUSES*STATUS*USER*SCREEN_NAME":
			$parsed_arr[$counter]->screen_name .= $data;
			break;
		case "*STATUSES*STATUS*USER*NAME":
			$parsed_arr[$counter]->name .= $data;
			break;
		case "*STATUSES*STATUS*USER*PROFILE_IMAGE_URL":
			$parsed_arr[$counter]->purl .= $data;
			break;
		case "*STATUSES*STATUS*USER*PROTECTED":
			if ($data == "true") {
				$parsed_arr[$counter]->protected = "1";
			} else {
				$parsed_arr[$counter]->protected = "0";
			}
			break;
		case "*STATUSES*STATUS":
		case "*STATUSES*STATUS*SOURCE":
		case "*STATUSES*STATUS*TRUNCATED":
		case "*STATUSES*STATUS*FAVORITED":
		case "*STATUSES*STATUS*USER*LOCATION":
		case "*STATUSES":
		case "*STATUSES*STATUS*IN_REPLY_TO_STATUS_ID":
		case "*STATUSES*STATUS*IN_REPLY_TO_USER_ID":
		case "*STATUSES*STATUS*IN_REPLY_TO_SCREEN_NAME":
		case "*STATUSES*STATUS*USER":
		case "*STATUSES*STATUS*USER*DESCRIPTION":
		case "*STATUSES*STATUS*USER*URL":
		case "*STATUSES*STATUS*USER*FOLLOWERS_COUNT":
			// ignore
			break;
		default:
			echo "<!-- " . $counter . " unsupported friendtimeline tag: " 
			. $current_tag . " = " . $data . " -->\n";
			break;
	}
}

// dm parser
class dm_status{
	var $created, $text, $tid, $sid, $rid, $sname, $rname, $purl;
}

function dm_contents($parser, $data) {
	global $current_tag, $parsed_arr, $counter;

	//echo $current_tag . ": " . $data . " (" . $counter . ")<br/>\n";
	switch($current_tag){
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*ID":
			$counter++;
			$parsed_arr[$counter] = new dm_status();
			$parsed_arr[$counter]->tid = $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*CREATED_AT":
			//'YYYY-MM-DD HH:MM:SS' Fri Apr 13 02:51:08 +0000 2007
			$parsed_arr[$counter]->created .= $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*TEXT":
			$parsed_arr[$counter]->text .= $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*ID":
			$parsed_arr[$counter]->sid = $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*SCREEN_NAME":
			$parsed_arr[$counter]->sname .= $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*SCREEN_NAME":
			$parsed_arr[$counter]->rname .= $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*ID":
			$parsed_arr[$counter]->rid .= $data;
			break;
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*PROFILE_IMAGE_URL":
			$parsed_arr[$counter]->purl .= $data;
			break;
		case "*DIRECT-MESSAGES":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER_ID":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*NAME":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*LOCATION":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*DESCRIPTION":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*URL":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*PROTECTED":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER*FOLLOWERS_COUNT":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*SENDER_SCREEN_NAME":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT_ID":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*NAME":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*LOCATION":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*DESCRIPTION":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*PROFILE_IMAGE_URL":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*URL":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*PROTECTED":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT*FOLLOWERS_COUNT":
		case "*DIRECT-MESSAGES*DIRECT_MESSAGE*RECIPIENT_SCREEN_NAME": 
			// ignore
			break;
		default:
			echo "<!-- " . $counter . " unsupported friendtimeline tag: " 
			. $current_tag . " = " . $data . " -->\n";
			break;
	}
}

function startTag($parser, $data){
	global $current_tag;
	$current_tag .= "*$data";
}

function endTag($parser, $data){
	global $current_tag;
	$tag_key = strrpos($current_tag, '*');
	$current_tag = substr($current_tag, 0, $tag_key);
} 

?>
